#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Category Searches
# DIZ: Enables you to set up category searches.
# GRAPHIC: add.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2007 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

if ($q->param('fct') eq "") { &start; }


####################################################################################

sub start
{

print "Content-type: text/html\n\n";

print qq[
<html>

<head>
<title>PowerSeek</title>
</head>

<body>

<table border="0" cellpadding="6" cellspacing="1" width="100%">
  <tr>
    <td width="1%" valign="top"><p align="center"><img src="$web_url/add.gif"></td>
    <td width="95%" valign="top"><font face="Arial" size="4"><strong>Category Searches</strong></font><font
    color="#0000a0" face="Arial" size="4"><br>
    </font><font face="Verdana" size="1">This plugin allows you to create searches that will
    only search specific categories.</font><p><font face="Verdana" size="1"><strong>Instructions:<br>
    </strong>Select a category. In the HTML code box below there will be HTML code that you
    can place inside any web page or PowerSeek template to have visitors search the category
    you selected.</font></td>
  </tr>
</table>

<hr noshade size="1" color="#F2F2F2">
];



$ct = $q->param('ct'); ### ORIGINAL CAT
$cid = $q->param('cid'); ### ORIGINAL CID
$rid = $q->param('rid'); ### ORIGINAL RID

$mct = $q->param('mct'); ### TO MOVE TO CAT
$mlv = $q->param('mlv'); ### TO MOVE LEVEL
$mcid = $q->param('mcid'); ### TO MOVE CID


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 
########

if ($mlv == 0)
	{
	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '1') AND ((crosslinkid IS NULL) OR (crosslinkid < 1)) ORDER BY shortname ASC");
	}
	else
	{
	$mlv++;
	@adir = split (/-/, $mct);
	
	$querystr = "";

	for ($ms = 0; $ms < 16; $ms++) 
		{
		if ($adir[$ms] ne "") {$adir[$ms] = acs::decode_dir($adir[$ms]);}

		$acnt = $ms + 1;
		if ($acnt != $mlv)
			{
			if ($adir[$ms] ne "")
				{
				$adir[$ms] =~ s/'/\\'/g;
				}
			$querystr = $querystr . " (l" . "$acnt = '$adir[$ms]') and";
			}
		$acnt++;
		}
	$querystr = substr($querystr, 0, length($querystr) - 3);
	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '$mlv') AND $querystr AND ((crosslinkid IS NULL) OR (crosslinkid < 1)) ORDER BY shortname ASC");
	
	}

##############

if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }

$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$rows = $sth->rows();

$smc = 0;
while ( @row = $sth->fetchrow() )
	{
	$mlv = $row[1];

	$row[2] = acs::encode_dir($row[2]); $dirstring = $row[2];														#1
	if ($row[3] ne "") { $row[3] = acs::encode_dir($row[3]); $dirstring =   $dirstring . "-$row[3]"; } #2
	if ($row[4] ne "") { $row[4] = acs::encode_dir($row[4]); $dirstring =   $dirstring . "-$row[4]"; } #3
	if ($row[5] ne "") { $row[5] = acs::encode_dir($row[5]); $dirstring =   $dirstring . "-$row[5]"; } #4
	if ($row[6] ne "") { $row[6] = acs::encode_dir($row[6]); $dirstring =   $dirstring . "-$row[6]"; } #5
	if ($row[7] ne "") { $row[7] = acs::encode_dir($row[7]); $dirstring =   $dirstring . "-$row[7]"; } #6
	if ($row[8] ne "") { $row[8] = acs::encode_dir($row[8]); $dirstring =   $dirstring . "-$row[8]"; } #7
	if ($row[9] ne "") { $row[9] = acs::encode_dir($row[9]); $dirstring =   $dirstring . "-$row[9]"; } #8
	if ($row[10] ne ""){ $row[10] = acs::encode_dir($row[10]); $dirstring = $dirstring ."-$row[10]"; } #9
	
	if ($row[11] ne ""){ $row[10] = acs::encode_dir($row[11]); $dirstring = $dirstring ."-$row[11]"; } #10
	if ($row[12] ne ""){ $row[10] = acs::encode_dir($row[12]); $dirstring = $dirstring ."-$row[12]"; } #11
	if ($row[13] ne ""){ $row[10] = acs::encode_dir($row[13]); $dirstring = $dirstring ."-$row[13]"; } #12
	if ($row[14] ne ""){ $row[10] = acs::encode_dir($row[14]); $dirstring = $dirstring ."-$row[14]"; } #13
	if ($row[15] ne ""){ $row[10] = acs::encode_dir($row[15]); $dirstring = $dirstring ."-$row[15]"; } #14
	if ($row[16] ne ""){ $row[10] = acs::encode_dir($row[16]); $dirstring = $dirstring ."-$row[16]"; } #15
	if ($row[17] ne ""){ $row[10] = acs::encode_dir($row[17]); $dirstring = $dirstring ."-$row[17]"; } #16

	if ($row[20] eq "") { $row[20] = 0; }

	$locked_stat = "";
	if ($row[22] eq "Y") { $locked_stat = " <img src=\"$web_url/locked.gif\">"; }

	if ($last_dname eq "") { $last_dname = "Root "; }
	if ($smc == 0) 
		{
		$movedirs = $movedirs . " <img src=\"$web_url/dir.gif\"> <b>$last_dname</b> <br>";
		$selbox = "checked";
		}
		else
		{
		$selbox = "";
		}
	$smc++;
	
	$moveval = "$row[0]" . "___MVSPLT___" . "$row[28]";
	
	$movedirs = $movedirs . "<input type=\"radio\" name=\"movecat\" $selbox value=\"$dirstring\" onclick=\"get_search_form('$dirstring');\"\> <img src=\"$web_url/subdir.gif\"> <a href=\"$admin_url/p_dirsearch.cgi?mlv=$mlv&mct=$dirstring&cid=$row[0]&ct=$ct&$selstring\">$row[28]</a></strong> ($row[20]) $locked_stat<br>";
	
	$oid = $row[0];
	}

$sth->finish;
$dbh->disconnect;



#### CURRENT MOVE LOCATION

if ($mct eq "")
	{
	$currentloc = "Root ";
	}
	else
	{
	$currentloc = "<a href=\"$admin_url/p_dirsearch.cgi?mlv=&mct=&cid=$cid&rid=$rid&ct=$ct&fct=$fct&$selstring&opaction=$opaction&$newsub&linkchk=$linkchk\">Root</a> ";
	
	$n_mlv = 1;
	
	@allds = split (/-/, $mct);
	$ccnr = @allds;

	foreach $aitem (@allds)
		{
		$n_mct = $n_mct . $aitem . "-";
		
		$cdname = acs::decode_dir($aitem);
		
		$cnn_mct = substr($n_mct, 0, length($n_mct) - 1);
		
		if ($ccnr ne $n_mlv)
			{
			$currentloc = $currentloc . " > <a href=\"$admin_url/p_dirsearch.cgi?mlv=$n_mlv&mct=$cnn_mct&cid=$cid&rid=$rid&ct=$ct&fct=$fct&$selstring&opaction=$opaction&$newsub&linkchk=$linkchk\">$cdname</a> ";
			}
			else
			{
			$currentloc = $currentloc . " > $cdname ";
			}
		
		$n_mlv++;
		}
	
	}

#### 

if ($dirstring !~ /-/)
	{
	$pmct = "";
	}
	else
	{
	$pmct = "$mct";
	}


#####

if ($mlv eq "")
	{
	$create_lv = 0;
	}
	else
	{
	$create_lv = $mlv -1;
	}

if ($rows == 0)
	{
$movedirs = <<END_OF_NONE;

<p><font face="Verdana" size="1" color="#FF8000"><strong>This category contains no sub
directories/categories. <br>
</strong></font><font face="Verdana" size="1" color="#000000">Use the back button of your
browser to go back.</font></p>

END_OF_NONE
	}
	elsif ($q->param('fct') eq "")
	{
		$movebut = "<input type=\"submit\" value=\"   Assign   \" name=\"movebutton\" style=\"font-family: MS Sans Serif; font-size: 8\" onclick=\"post_value();\">";
	}
	elsif ($q->param('fct') eq "related")
	{
	
		if ($q->param('linkchk') eq "true")
		{
		$movebut = "<input type=\"submit\" value=\"   Assign   \" name=\"movebutton\" style=\"font-family: MS Sans Serif; font-size: 8\" onclick=\"post_value3(); return false;\">";
		$linkchk = "true";
		}
		else
		{
		$movebut = "<input type=\"submit\" value=\"   Assign   \" name=\"movebutton\" style=\"font-family: MS Sans Serif; font-size: 8\" onclick=\"post_value2(); return false;\">";
		}
		
	}

###############


$gsettings = new_gsettings acs;

if ($gsettings->{searchmeth} eq "fulltext")
{
$searchsc = "search2.cgi";
}
else
{
$searchsc = "search.cgi";
}



print <<END_OF_MVL;

<html>
<head>
<title>Select a Category</title>

<script LANGUAGE="JavaScript">
<!-- Hide

  function get_search_form(passonv)
   {
		 asform.S1.value = '<form method=\"POST\" action=\"$script_url/$searchsc\"><input type=\"hidden\" name=\"cat_search\" value=\"CST_' + passonv + '\"><input type=\"text\" name=\"keywords\" size=\"31\" value><input type=\"submit\" value=\"Search\" name=\"Search\"></form>';
   }
   
// End Hide -->
</script>



</head>
<body>
<form method="POST" action="$movecgi" name="asform" >
  <input type="hidden" name="fct" value="$fct">
  <input type="hidden" name="ct" value="$ct">
  <input type="hidden" name="links_to_move" value="$hselstring">
  <input type="hidden" name="cid" value="$cid">
  <input type="hidden" name="rid" value="$rid">
  <input type="hidden" name="mct" value="$pmct">
  <input type="hidden" name="newsub" value="$newsub2">
  <input type="hidden" name="email" value="$newsubemail">
  <input type="hidden" name="lastid" value="$oid">
  

<font face="Verdana" size="1"><div align="center"><center>

<table border="0" cellpadding="6" cellspacing="0" width="100%">
  <tr>
    <td width="50%" valign="top"><font face="Verdana" size="1" color="#000000"><strong>Current
    Location: </strong><img src="$web_url/lar.gif" width="6" height="10"> <b>$currentloc</b></font><blockquote>
      <p><font face="Verdana" size="1" color="#000000">$movedirs</font></p>
    </blockquote>
    </td>
    <td width="50%" valign="top" style="border-left: 1px solid rgb(239,239,239)"><font
    face="Verdana" size="1" color="#000000"><strong>Category Search HTML Code:<br>
    </strong>When choosing a category on the righ, HTML code will be displayed in the box
    below that you can use to provide your visitors with specific category searches:</font><form
    method="POST" action="$admin_url/admin.cgi">
      <p><font face="Verdana" size="1" color="#000000">
      
      <p align="center">
      <textarea rows="12" name="S1" cols="30">$shtmlcode</textarea>
      </p>
      
      </font></p>
    </form>
    </td>
  </tr>
</table>
</center></div>

<p>&nbsp;</p>
</font>

</form>


</body>
</html>


END_OF_MVL



}



sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

